import unittest
import io
import contextlib
from unittest.mock import patch

from tmc import points

from tmc.utils import load, get_stdout
main = load('src.main', 'main')


@points('1.5')
class MainTest(unittest.TestCase):

    def test_00_something_is_printed(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        if not printed:
            self.fail('Et tulostanut mitään!')

    def test_01_prints_correct_sum(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        first_line = printed.split('\n')[0].strip()
        self.assertEqual(first_line, '3', msg='Summa ei ole oikein.')

    def test_02_prints_all_to_different_lines(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        lines = printed.split('\n')
        self.assertTrue(len(lines)>1,msg='Et tulostanut kahta riviä.')

    def test_03_prints_correct_cosine(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        second_line = printed.split('\n')[1].strip()
        import numpy as np
        self.assertEqual(round(float(second_line),6), round(np.cos(3),6), msg='Cos arvo ei ollut oikein.')

    def test_04_uses_cos_function(self):

        self.longMessage = False

        # Get absolute path to main file:
        import os
        test_path = os.path.dirname(os.path.realpath(__file__))
        main_path = os.path.abspath(os.path.join(test_path, "../src/main.py"))

        # Read contents of main:
        main_file = open(main_path, 'r')
        lines = main_file.readlines()
        lines = [line.split('#')[0] for line in lines] # Remove comments
        # Get list of words (alphanumeric strings) in lines:
        import re
        words = [word.lower() for line in lines for word in re.split('\W+', line)]
        self.assertTrue(('cos' in words), msg='Et käyttänyt cos-funktiota')

        main_file.close()
